// ViewDlg.h : interface of the CViewDlg class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <atlmisc.h>
#include "FilePreviewCtrl.h"

class CViewDlg : public CDialogImpl<CViewDlg>,
    public CMessageFilter,
    public CDialogResize<CViewDlg>
{
public:
    CViewDlg(CString strFilePath);

    void ShowFile(CString strFilePath);

    enum { IDD = IDD_DIALOG_VIEW };

    BEGIN_DLGRESIZE_MAP(CViewDlg)
        DLGRESIZE_CONTROL(IDC_STATIC_PREVIEW, DLSZ_SIZE_X|DLSZ_SIZE_Y)
        DLGRESIZE_CONTROL(IDOK, DLSZ_MOVE_X|DLSZ_MOVE_Y)
    END_DLGRESIZE_MAP()

    BEGIN_MSG_MAP(CViewDlg)
        MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
        MESSAGE_HANDLER(WM_MOUSEWHEEL, OnMouseWheel)
        COMMAND_ID_HANDLER(IDOK, OnOK)
        COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
        CHAIN_MSG_MAP(CDialogResize<CViewDlg>)
    END_MSG_MAP()

    LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
    LRESULT OnMouseWheel(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
    LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    virtual BOOL PreTranslateMessage(MSG* pMsg);

protected:
    CString m_strFilePath;
    CFilePreviewCtrl m_FilePreview;
};
